
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class FilesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const files = await db.files.create(
            {
                id: data.id || undefined,
        
        file_name: data.file_name
        ||
        null
            ,
            
        file_kind: data.file_kind
        ||
        null
            ,
            
        size_mb: data.size_mb
        ||
        null
            ,
            
        mime_type: data.mime_type
        ||
        null
            ,
            
        storage_uri: data.storage_uri
        ||
        null
            ,
            
        checksum_sha256: data.checksum_sha256
        ||
        null
            ,
            
        scan_status: data.scan_status
        ||
        null
            ,
            
        uploaded_at: data.uploaded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await files.setTenant( data.tenant || null, {
            transaction,
        });
        
        await files.setUploaded_by( data.uploaded_by || null, {
            transaction,
        });
        
        await files.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return files;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const filesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                file_name: item.file_name
            ||
            null
            ,
            
                file_kind: item.file_kind
            ||
            null
            ,
            
                size_mb: item.size_mb
            ||
            null
            ,
            
                mime_type: item.mime_type
            ||
            null
            ,
            
                storage_uri: item.storage_uri
            ||
            null
            ,
            
                checksum_sha256: item.checksum_sha256
            ||
            null
            ,
            
                scan_status: item.scan_status
            ||
            null
            ,
            
                uploaded_at: item.uploaded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const files = await db.files.bulkCreate(filesData, { transaction });

        // For each item created, replace relation files
        

        return files;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const files = await db.files.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.file_name !== undefined) updatePayload.file_name = data.file_name;
        
        
        if (data.file_kind !== undefined) updatePayload.file_kind = data.file_kind;
        
        
        if (data.size_mb !== undefined) updatePayload.size_mb = data.size_mb;
        
        
        if (data.mime_type !== undefined) updatePayload.mime_type = data.mime_type;
        
        
        if (data.storage_uri !== undefined) updatePayload.storage_uri = data.storage_uri;
        
        
        if (data.checksum_sha256 !== undefined) updatePayload.checksum_sha256 = data.checksum_sha256;
        
        
        if (data.scan_status !== undefined) updatePayload.scan_status = data.scan_status;
        
        
        if (data.uploaded_at !== undefined) updatePayload.uploaded_at = data.uploaded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await files.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await files.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.uploaded_by !== undefined) {
            await files.setUploaded_by(
              
              data.uploaded_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await files.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return files;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const files = await db.files.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of files) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of files) {
                await record.destroy({transaction});
            }
        });


        return files;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const files = await db.files.findByPk(id, options);

        await files.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await files.destroy({
            transaction
        });

        return files;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const files = await db.files.findOne(
            { where },
            { transaction },
        );

        if (!files) {
            return files;
        }

        const output = files.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.room_files_file = await files.getRoom_files_file({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await files.getTenant({
            transaction
        });
        
        
        output.uploaded_by = await files.getUploaded_by({
            transaction
        });
        
        
        output.organizations = await files.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'uploaded_by',
        
        where: filter.uploaded_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uploaded_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.uploaded_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.file_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'files',
                        'file_name',
                        filter.file_name,
                    ),
                };
            }
            
            if (filter.mime_type) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'files',
                        'mime_type',
                        filter.mime_type,
                    ),
                };
            }
            
            if (filter.storage_uri) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'files',
                        'storage_uri',
                        filter.storage_uri,
                    ),
                };
            }
            
            if (filter.checksum_sha256) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'files',
                        'checksum_sha256',
                        filter.checksum_sha256,
                    ),
                };
            }
            

            
            

            
            if (filter.size_mbRange) {
                const [start, end] = filter.size_mbRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    size_mb: {
                    ...where.size_mb,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    size_mb: {
                    ...where.size_mb,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.uploaded_atRange) {
                const [start, end] = filter.uploaded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    uploaded_at: {
                    ...where.uploaded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.file_kind) {
                where = {
                    ...where,
                file_kind: filter.file_kind,
            };
            }
            
            if (filter.scan_status) {
                where = {
                    ...where,
                scan_status: filter.scan_status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.files.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'files',
                        'file_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.files.findAll({
            attributes: [ 'id', 'file_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['file_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.file_name,
        }));
    }

    
};

